
Redmine - Patch #13468

REST API for News

2013-03-13 18:53 - C. X.

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 4.1.0   

Description

Some small changes for supporting news creation over REST.

Related issues:

Related to Redmine - Feature #26653: REST API - Add full CRUD support for News Closed

Associated revisions

Revision 18440 - 2019-09-09 10:52 - Go MAEDA

REST API for creating news (#13468).

Patch by Takenori TAKAKI.

Revision 18441 - 2019-09-09 10:55 - Go MAEDA

REST API for retrieving news (#13468).

Patch by Takenori TAKAKI.

Revision 18442 - 2019-09-09 10:57 - Go MAEDA

REST API for deleting news (#13468).

Patch by Takenori TAKAKI.

Revision 18443 - 2019-09-09 11:03 - Go MAEDA

REST API for updating news (#13468).

Patch by Takenori TAKAKI.

Revision 18445 - 2019-09-11 03:53 - Go MAEDA

Fix that Redmine::ApiTest::NewsTest fails when config.time_zone is set (#13468).

Patch by Yuichi HARADA.

Revision 18455 - 2019-09-12 14:51 - Go MAEDA

Add missing fixture (#13468).

History

#1 - 2013-03-13 23:30 - Mischa The Evil

- Category set to REST API

#2 - 2017-09-07 09:36 - Go MAEDA

- Related to Feature #26653: REST API - Add full CRUD support for News added

#3 - 2018-02-01 03:27 - Jesse Hopkins

+1

#4 - 2018-03-06 16:21 - Guillaume Masclet

Hi, is this patch planned to be merged in an upcoming release ?

This would be great as I have to make a few dozen announcements each month on some of the projects I manage with Redmine. This is really

tedious without automation.
#5 - 2019-03-29 07:34 - Takenori TAKAKI

- File news-creating-via-api.patch added

I made a patch with small changes and tests to the C. X.'s patch.

I'm looking forward to using this feature in future Redmine.

#6 - 2019-03-29 08:30 - Go MAEDA

- Target version set to Candidate for next major release

#7 - 2019-04-01 15:46 - Go MAEDA

It looks a bit awkward to me to implement POST only without implementing GET, PUT, and DELETE. I think that GET should be implemented at

least.

With the current patch implemented, users can create news but they don't have the means to retrieve the news using an id.

#8 - 2019-04-04 17:07 - Takenori TAKAKI

- File 0001-news-creating-via-api.patch added

- File 0002-news-getting-via-api.patch added

- File 0003-news-deleting-via-api.patch added

- File 0004-news-updating-via-api.patch added

Go MAEDA wrote:

It looks a bit awkward to me to implement POST only without implementing GET, PUT, and DELETE. I think that GET should be implemented at

least.

 Certainly, that is more beautiful as an API design.

I made a patch so that POST, GET, DELETE and PUT functions can be added gradually.

#9 - 2019-04-11 01:07 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

#10 - 2019-04-19 17:44 - Go MAEDA

- Target version deleted (4.1.0)

#11 - 2019-06-20 17:00 - Go MAEDA

- Target version set to 4.1.0

#12 - 2019-09-09 07:15 - vzvu 3k6k

+1, Takaki's patches look good to me.

#13 - 2019-09-09 11:06 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patches. Thank you for your contribution. And vzvu 3k6k, thank you for reviewing the patches. Your review is very helpful to me.

#14 - 2019-09-09 16:09 - Go MAEDA

- Subject changed from News creation over REST to REST API for News

#15 - 2019-09-10 08:16 - Yuichi HARADA

Redmine::ApiTest::NewsTest#test_GET_/news/:id.xml fails if config.time_zone is set.

Set config.time_zone in config/additional_environment.rb.

config.time_zone = 'Tokyo'

 The tests suppose that time in API response is always in UTC, but it varies depending on the value of config.time_zone is set.
$ RAILS_ENV=test bundle exec rake test TEST=test/integration/api_test/news_test.rb

Run options: --seed 35340

# Running:

...................F

Failure:

Redmine::ApiTest::NewsTest#test_GET_/news/:id.xml [test/integration/api_test/news_test.rb:69]:

<(?-mix:^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}Z$)> expected but was

<2006-07-20T05:40:26+09:00>..

Expected 0 to be >= 1.

bin/rails test test/integration/api_test/news_test.rb:65

...

Finished in 1.647332s, 13.9620 runs/s, 75.2732 assertions/s.

23 runs, 124 assertions, 1 failures, 0 errors, 0 skips

 The following patch will solve it.

diff --git a/test/integration/api_test/news_test.rb b/test/integration/api_test/news_test.rb

index a6ca416a8..a7fccf9b6 100644

--- a/test/integration/api_test/news_test.rb

+++ b/test/integration/api_test/news_test.rb

@@ -73,8 +73,7 @@ class Redmine::ApiTest::NewsTest < Redmine::ApiTest::Base

       assert_select 'title', 'eCookbook first release !'

       assert_select 'summary', 'First version was released...'

       assert_select 'description', "eCookbook 1.0 has been released.\n\nVisit http://ecookbook.somenet.foo/" 

-      iso_date = /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}Z$/

-      assert_select 'news>created_on', :text => iso_date

+      assert_select 'created_on', News.find(1).created_on.iso8601

     end

   end

#16 - 2019-09-11 03:53 - Go MAEDA

Yuichi HARADA wrote:

Redmine::ApiTest::NewsTest#test_GET_/news/:id.xml fails if config.time_zone is set.

 Committed the fix in r18445. Thank you for reporting and fixing it.

#17 - 2019-09-11 07:15 - vzvu 3k6k

Sorry, I should have run tests locally before commenting.

Thanks for fixing.

#18 - 2019-09-12 14:48 - Go MAEDA

- Status changed from Closed to Reopened

The test fails due to a missing fixture.

$ RAILS_ENV=test bin/rake db:reset

$ bin/rails test test/integration/api_test/news_test.rb:88

Run options: --seed 61590

# Running:

E

Error:

Redmine::ApiTest::NewsTest#test_GET_/news/:id.xml_with_attachments:

NoMethodError: undefined method `container=' for nil:NilClass

Did you mean?  concern

    test/integration/api_test/news_test.rb:91:in `block in <class:NewsTest>'

 It can be fixed with the following patch.

Index: test/integration/api_test/news_test.rb

===================================================================
--- test/integration/api_test/news_test.rb    (リビジョン 18453)

+++ test/integration/api_test/news_test.rb    (作業コピー)

@@ -28,7 +28,8 @@

            :members,

            :enabled_modules,

            :news,

-           :comments

+           :comments,

+           :attachments

   test "GET /news.xml should return news" do

     get '/news.xml'

#19 - 2019-09-12 14:51 - Go MAEDA

- Status changed from Reopened to Closed

Go MAEDA wrote:

The test fails due to a missing fixture.

 Committed in r18455.

Files

news.patch 1.32 KB 2013-03-13 C. X.

news-creating-via-api.patch 7.1 KB 2019-03-29 Takenori TAKAKI

0002-news-getting-via-api.patch 4.71 KB 2019-04-04 Takenori TAKAKI

0001-news-creating-via-api.patch 7.48 KB 2019-04-04 Takenori TAKAKI

0003-news-deleting-via-api.patch 2.08 KB 2019-04-04 Takenori TAKAKI

0004-news-updating-via-api.patch 5.65 KB 2019-04-04 Takenori TAKAKI
